/[gentoo-x86]/eclass/qt4-build.eclass
Gentoo

Diff of /eclass/qt4-build.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.76 Revision 1.149
1# Copyright 1999-2009 Gentoo Foundation 1# Copyright 1999-2013 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.76 2010/07/03 15:49:39 ayoy Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/qt4-build.eclass,v 1.149 2013/08/13 10:05:37 pesa Exp $
4 4
5# @ECLASS: qt4-build.eclass 5# @ECLASS: qt4-build.eclass
6# @MAINTAINER: 6# @MAINTAINER:
7# Ben de Groot <yngwin@gentoo.org>, 7# Qt herd <qt@gentoo.org>
8# Markos Chandras <hwoarang@gentoo.org>,
9# Caleb Tennis <caleb@gentoo.org>
10# Alex Alexander <wired@gentoo.org>
11# @BLURB: Eclass for Qt4 split ebuilds. 8# @BLURB: Eclass for Qt4 split ebuilds.
12# @DESCRIPTION: 9# @DESCRIPTION:
13# This eclass contains various functions that are used when building Qt4 10# This eclass contains various functions that are used when building Qt4.
14 11
12case ${EAPI} in
13 4|5) : ;;
14 *) die "qt4-build.eclass: unsupported EAPI=${EAPI:-0}" ;;
15esac
16
15inherit base eutils multilib toolchain-funcs flag-o-matic versionator 17inherit eutils flag-o-matic multilib toolchain-funcs versionator
18
19if [[ ${PV} == *9999* ]]; then
20 QT4_BUILD_TYPE="live"
21 inherit git-2
22else
23 QT4_BUILD_TYPE="release"
24fi
25
26HOMEPAGE="http://qt-project.org/ http://qt.digia.com/"
27LICENSE="|| ( LGPL-2.1 GPL-3 )"
16 28
17MY_PV=${PV/_/-} 29MY_PV=${PV/_/-}
18if version_is_at_least 4.5.99999999; then
19 MY_P=qt-everywhere-opensource-src-${MY_PV} 30MY_P=qt-everywhere-opensource-src-${MY_PV}
31
32case ${QT4_BUILD_TYPE} in
33 live)
34 EGIT_REPO_URI="git://gitorious.org/qt/qt.git
35 https://git.gitorious.org/qt/qt.git"
36 EGIT_BRANCH=${PV%.9999}
37 ;;
38 release)
39 SRC_URI="http://download.qt-project.org/official_releases/qt/${PV%.*}/${PV}/${MY_P}.tar.gz"
40 ;;
41esac
42
43IUSE="aqua debug pch"
44[[ ${CATEGORY}/${PN} != dev-qt/qtwebkit ]] && IUSE+=" c++0x"
20 [[ ${CATEGORY}/${PN} != x11-libs/qt-xmlpatterns ]] && IUSE="+exceptions" 45[[ ${CATEGORY}/${PN} != dev-qt/qtxmlpatterns ]] && IUSE+=" +exceptions"
21else 46
22 MY_P=qt-x11-opensource-src-${MY_PV} 47DEPEND="virtual/pkgconfig"
48if [[ ${QT4_BUILD_TYPE} == live ]]; then
49 DEPEND+=" dev-lang/perl"
23fi 50fi
24 51
25HOMEPAGE="http://qt.nokia.com/"
26SRC_URI="http://get.qt.nokia.com/qt/source/${MY_P}.tar.gz"
27
28LICENSE="|| ( LGPL-2.1 GPL-3 )"
29IUSE+=" debug pch aqua"
30
31RDEPEND="
32 !<x11-libs/qt-assistant-${PV}
33 !>x11-libs/qt-assistant-${PV}-r9999
34 !<x11-libs/qt-core-${PV}
35 !>x11-libs/qt-core-${PV}-r9999
36 !<x11-libs/qt-dbus-${PV}
37 !>x11-libs/qt-dbus-${PV}-r9999
38 !<x11-libs/qt-demo-${PV}
39 !>x11-libs/qt-demo-${PV}-r9999
40 !<x11-libs/qt-gui-${PV}
41 !>x11-libs/qt-gui-${PV}-r9999
42 !<x11-libs/qt-multimedia-${PV}
43 !>x11-libs/qt-multimedia-${PV}-r9999
44 !<x11-libs/qt-opengl-${PV}
45 !>x11-libs/qt-opengl-${PV}-r9999
46 !<x11-libs/qt-phonon-${PV}
47 !>x11-libs/qt-phonon-${PV}-r9999
48 !<x11-libs/qt-qt3support-${PV}
49 !>x11-libs/qt-qt3support-${PV}-r9999
50 !<x11-libs/qt-script-${PV}
51 !>x11-libs/qt-script-${PV}-r9999
52 !<x11-libs/qt-sql-${PV}
53 !>x11-libs/qt-sql-${PV}-r9999
54 !<x11-libs/qt-svg-${PV}
55 !>x11-libs/qt-svg-${PV}-r9999
56 !<x11-libs/qt-test-${PV}
57 !>x11-libs/qt-test-${PV}-r9999
58 !<x11-libs/qt-webkit-${PV}
59 !>x11-libs/qt-webkit-${PV}-r9999
60 !<x11-libs/qt-xmlpatterns-${PV}
61 !>x11-libs/qt-xmlpatterns-${PV}-r9999
62"
63
64S=${WORKDIR}/${MY_P} 52S=${WORKDIR}/${MY_P}
65 53
66# @FUNCTION: qt4-build_pkg_setup 54# @FUNCTION: qt4-build_pkg_setup
67# @DESCRIPTION: 55# @DESCRIPTION:
68# Sets up S, MY_P, PATH, and LD_LIBRARY_PATH 56# Sets up PATH and LD_LIBRARY_PATH.
69qt4-build_pkg_setup() { 57qt4-build_pkg_setup() {
70 [[ ${EAPI} == 2 ]] && use !prefix && EPREFIX=
71
72 # Protect users by not allowing downgrades between releases 58 # Protect users by not allowing downgrades between releases.
73 # Downgrading revisions within the same release should be allowed 59 # Downgrading revisions within the same release should be allowed.
74 if has_version '>'${CATEGORY}/${P}-r9999 ; then 60 if has_version ">${CATEGORY}/${P}-r9999:4"; then
75 if [[ -z $I_KNOW_WHAT_I_AM_DOING ]] ; then 61 if [[ -z ${I_KNOW_WHAT_I_AM_DOING} ]]; then
76 eerror "Sanity check to keep you from breaking your system:" 62 eerror " *** Sanity check to keep you from breaking your system ***"
77 eerror " Downgrading Qt is completely unsupported and will break your system!" 63 eerror "Downgrading Qt is completely unsupported and will break your system!"
78 die "aborting to save your system" 64 die "aborting to save your system"
79 else 65 else
80 ewarn "Downgrading Qt is completely unsupported and will break your system!" 66 ewarn "Downgrading Qt is completely unsupported and will break your system!"
81 fi 67 fi
82 fi
83
84 if [[ "${PN}" == "qt-webkit" ]]; then
85 eshopts_push -s extglob
86 if is-flagq '-g?(gdb)?([0-9])'; then
87 echo
88 ewarn "You have enabled debug info (probably have -g or -ggdb in your \$C{,XX}FLAGS)."
89 ewarn "You may experience really long compilation times and/or increased memory usage."
90 ewarn "If compilation fails, please try removing -g{,gdb} before reporting a bug."
91 ewarn "For more info check out bug #307861"
92 echo
93 fi
94 eshopts_pop
95 fi 68 fi
96 69
97 PATH="${S}/bin${PATH:+:}${PATH}" 70 PATH="${S}/bin${PATH:+:}${PATH}"
98 if [[ ${CHOST} != *-darwin* ]]; then 71 if [[ ${CHOST} != *-darwin* ]]; then
99 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}" 72 LD_LIBRARY_PATH="${S}/lib${LD_LIBRARY_PATH:+:}${LD_LIBRARY_PATH}"
104 # avoid extract failure. 77 # avoid extract failure.
105 [[ ${CHOST} == *-apple-darwin* ]] && \ 78 [[ ${CHOST} == *-apple-darwin* ]] && \
106 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm 79 QT4_EXTRACT_DIRECTORIES="src/gui/kernel/qapplication_mac.mm
107 ${QT4_EXTRACT_DIRECTORIES}" 80 ${QT4_EXTRACT_DIRECTORIES}"
108 fi 81 fi
109
110 # Make sure ebuilds use the required EAPI
111 if [[ ${EAPI} != [23] ]]; then
112 eerror "The qt4-build eclass requires EAPI=2 or EAPI=3, but this ebuild is using"
113 eerror "EAPI=${EAPI:-0}. The ebuild author or editor failed. This ebuild needs to be"
114 eerror "fixed. Using qt4-build eclass without EAPI=2 or EAPI=3 will fail."
115 die "qt4-build eclass requires EAPI=2 or EAPI=3"
116 fi
117
118 if ! version_is_at_least 4.1 $(gcc-version); then
119 ewarn "Using a GCC version lower than 4.1 is not supported!"
120 fi
121} 82}
83
84# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
85# @DEFAULT_UNSET
86# @DESCRIPTION:
87# Space-separated list including the directories that will be extracted from
88# Qt tarball.
122 89
123# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES 90# @ECLASS-VARIABLE: QT4_TARGET_DIRECTORIES
91# @DEFAULT_UNSET
124# @DESCRIPTION: 92# @DESCRIPTION:
125# Arguments for build_target_directories. Takes the directories, in which the 93# Arguments for build_target_directories. Takes the directories in which the
126# code should be compiled. This is a space-separated list 94# code should be compiled. This is a space-separated list.
127
128# @ECLASS-VARIABLE: QT4_EXTRACT_DIRECTORIES
129# @DESCRIPTION:
130# Space separated list including the directories that will be extracted from Qt
131# tarball
132 95
133# @FUNCTION: qt4-build_src_unpack 96# @FUNCTION: qt4-build_src_unpack
134# @DESCRIPTION: 97# @DESCRIPTION:
135# Unpacks the sources 98# Unpacks the sources.
136qt4-build_src_unpack() { 99qt4-build_src_unpack() {
137 setqtenv 100 setqtenv
138 local target targets= 101
102 if ! version_is_at_least 4.1 $(gcc-version); then
103 ewarn "Using a GCC version lower than 4.1 is not supported."
104 elif use_if_iuse c++0x && ! version_is_at_least 4.4 $(gcc-version); then
105 ewarn "USE=c++0x requires GCC 4.4 or later."
106 fi
107
108 if [[ ${CATEGORY}/${PN} == dev-qt/qtwebkit ]]; then
109 eshopts_push -s extglob
110 if is-flagq '-g?(gdb)?([1-9])'; then
111 echo
112 ewarn "You have enabled debug info (probably have -g or -ggdb in your CFLAGS/CXXFLAGS)."
113 ewarn "You may experience really long compilation times and/or increased memory usage."
114 ewarn "If compilation fails, please try removing -g/-ggdb before reporting a bug."
115 ewarn "For more info check out https://bugs.gentoo.org/307861"
116 echo
117 fi
118 eshopts_pop
119 fi
120
121 case ${QT4_BUILD_TYPE} in
122 live)
123 git-2_src_unpack
124 ;;
125 release)
126 local tarball="${MY_P}.tar.gz" target= targets=
139 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \ 127 for target in configure LICENSE.GPL3 LICENSE.LGPL projects.pro \
140 src/{qbase,qt_targets,qt_install}.pri bin config.tests mkspecs qmake \ 128 src/{qbase,qt_targets,qt_install}.pri bin config.tests \
141 ${QT4_EXTRACT_DIRECTORIES}; do 129 mkspecs qmake ${QT4_EXTRACT_DIRECTORIES}
130 do
142 targets+=" ${MY_P}/${target}" 131 targets+="${MY_P}/${target} "
143 done 132 done
144 133
134 ebegin "Unpacking parts of ${tarball}:" ${targets//${MY_P}\/}
145 echo tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets} 135 tar -xzf "${DISTDIR}/${tarball}" ${targets}
146 tar xzf "${DISTDIR}"/${MY_P}.tar.gz ${targets} || die 136 eend $? || die "failed to unpack"
137 ;;
138 esac
147} 139}
148 140
149# @ECLASS-VARIABLE: PATCHES 141# @ECLASS-VARIABLE: PATCHES
142# @DEFAULT_UNSET
150# @DESCRIPTION: 143# @DESCRIPTION:
151# In case you have patches to apply, specify them in PATCHES variable. Make sure 144# PATCHES array variable containing all various patches to be applied.
152# to specify the full path. This variable is necessary for src_prepare phase. 145# This variable is expected to be defined in global scope of ebuild.
153# example: 146# Make sure to specify the full path. This variable is utilised in
154# PATCHES="${FILESDIR}"/mypatch.patch 147# src_prepare() phase.
155# ${FILESDIR}"/mypatch2.patch"
156# 148#
149# @CODE
150# PATCHES=( "${FILESDIR}/mypatch.patch"
151# "${FILESDIR}/patches_folder/" )
152# @CODE
157 153
158# @FUNCTION: qt4-build_src_prepare 154# @FUNCTION: qt4-build_src_prepare
159# @DESCRIPTION: 155# @DESCRIPTION:
160# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix 156# Prepare the sources before the configure phase. Strip CFLAGS if necessary, and fix
161# source files in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified on /etc/make.conf. 157# the build system in order to respect CFLAGS/CXXFLAGS/LDFLAGS specified in make.conf.
162qt4-build_src_prepare() { 158qt4-build_src_prepare() {
163 setqtenv 159 setqtenv
164 cd "${S}"
165 160
166 # fix qt 4.7 regression that skips -fvisibility=hidden 161 if [[ ${QT4_BUILD_TYPE} == live ]]; then
167 if version_is_at_least "4.7.0_beta1"; then 162 QTDIR="." ./bin/syncqt || die "syncqt failed"
168 sed -e "s/^gcc|g++)/*gcc|*g++)/" \
169 -i config.tests/unix/fvisibility.test ||
170 die "visibility fixing sed failed"
171 fi 163 fi
164
165 # avoid X11 dependency in non-gui packages
166 local nolibx11_pkgs="qtcore qtdbus qtscript qtsql qttest qtxmlpatterns"
167 has ${PN} ${nolibx11_pkgs} && qt_nolibx11
172 168
173 if use aqua; then 169 if use aqua; then
174 # provide a proper macx-g++-64 170 # provide a proper macx-g++-64
175 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir) 171 use x64-macos && ln -s macx-g++ mkspecs/$(qt_mkspecs_dir)
176 172
177 sed -e '/^CONFIG/s:app_bundle::' \ 173 sed -e '/^CONFIG/s:app_bundle::' \
178 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \ 174 -e '/^CONFIG/s:plugin_no_soname:plugin_with_soname absolute_library_soname:' \
179 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed failed" 175 -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
180 fi 176 fi
181 177
182 if [[ ${PN} != qt-core ]]; then 178 if [[ ${CATEGORY}/${PN} != dev-qt/qtcore ]]; then
183 skip_qmake_build_patch 179 skip_qmake_build
184 skip_project_generation_patch 180 skip_project_generation
185 symlink_binaries_to_buildtree 181 symlink_binaries_to_buildtree
186 fi 182 fi
187 183
188 if [[ ${CHOST} == *86*-apple-darwin* ]] ; then 184 if [[ ${CHOST} == *86*-apple-darwin* ]]; then
189 # qmake bus errors with -O2 but -O3 works 185 # qmake bus errors with -O2 or -O3 but -O1 works
186 # Bug 373061
190 replace-flags -O2 -O3 187 replace-flags -O[23] -O1
191 fi 188 fi
192 189
193 # Bug 178652 190 if use_if_iuse c++0x; then
194 if [[ $(gcc-major-version) == 3 ]] && use amd64; then 191 append-cxxflags -std=c++0x
195 ewarn "Appending -fno-gcse to CFLAGS/CXXFLAGS"
196 append-flags -fno-gcse
197 fi
198
199 # Unsupported old gcc versions - hardened needs this :(
200 if [[ $(gcc-major-version) -lt 4 ]] ; then
201 ewarn "Appending -fno-stack-protector to CXXFLAGS"
202 append-cxxflags -fno-stack-protector
203 # Bug 253127
204 sed -e "/^QMAKE_CFLAGS\t/ s:$: -fno-stack-protector-all:" \
205 -i "${S}"/mkspecs/common/g++.conf || die "sed ${S}/mkspecs/common/g++.conf failed"
206 fi 192 fi
207 193
208 # Bug 261632 194 # Bug 261632
209 if use ppc64; then 195 if use ppc64; then
210 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS" 196 ewarn "Appending -mminimal-toc to CFLAGS/CXXFLAGS"
211 append-flags -mminimal-toc 197 append-flags -mminimal-toc
212 fi 198 fi
213 199
214 # Bug 282984 && Bug 295530 200 # Respect CC, CXX, {C,CXX,LD}FLAGS in .qmake.cache
215 sed -e "s:\(^SYSTEM_VARIABLES\):CC=$(tc-getCC)\nCXX=$(tc-getCXX)\nCFLAGS=\"${CFLAGS}\"\nCXXFLAGS=\"${CXXFLAGS}\"\nLDFLAGS=\"${LDFLAGS}\"\n\1:" \ 201 sed -e "/^SYSTEM_VARIABLES=/i \
216 -i configure || die "sed qmake compilers failed" 202 CC='$(tc-getCC)'\n\
217 # bug 321335 203 CXX='$(tc-getCXX)'\n\
218 if version_is_at_least 4.6; then 204 CFLAGS='${CFLAGS}'\n\
219 find ./config.tests/unix -name "*.test" -type f -exec grep -lZ \$MAKE '{}' \; | \ 205 CXXFLAGS='${CXXFLAGS}'\n\
220 xargs -0 \ 206 LDFLAGS='${LDFLAGS}'\n\
221 sed -e "s:\(\$MAKE\):\1 CC=$(tc-getCC) CXX=$(tc-getCXX) LD=$(tc-getCXX) LINK=$(tc-getCXX):g" \ 207 QMakeVar set QMAKE_CFLAGS_RELEASE\n\
222 -i || die "sed test compilers failed" 208 QMakeVar set QMAKE_CFLAGS_DEBUG\n\
223 fi 209 QMakeVar set QMAKE_CXXFLAGS_RELEASE\n\
210 QMakeVar set QMAKE_CXXFLAGS_DEBUG\n\
211 QMakeVar set QMAKE_LFLAGS_RELEASE\n\
212 QMakeVar set QMAKE_LFLAGS_DEBUG\n"\
213 -i configure \
214 || die "sed SYSTEM_VARIABLES failed"
215
216 # Respect CC, CXX, LINK and *FLAGS in config.tests
217 find config.tests/unix -name '*.test' -type f -print0 | xargs -0 \
218 sed -i -e "/bin\/qmake/ s: \"\$SRCDIR/: \
219 'QMAKE_CC=$(tc-getCC)' 'QMAKE_CXX=$(tc-getCXX)' 'QMAKE_LINK=$(tc-getCXX)' \
220 'QMAKE_CFLAGS+=${CFLAGS}' 'QMAKE_CXXFLAGS+=${CXXFLAGS}' 'QMAKE_LFLAGS+=${LDFLAGS}'&:" \
221 || die "sed config.tests failed"
224 222
225 # Bug 172219 223 # Bug 172219
226 sed -e "s:X11R6/::" \ 224 sed -e 's:/X11R6/:/:' -i mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
227 -i "${S}"/mkspecs/$(qt_mkspecs_dir)/qmake.conf || die "sed ${S}/mkspecs/$(qt_mkspecs_dir)/qmake.conf failed"
228 225
229 if [[ ${CHOST} == *-darwin* ]]; then 226 if [[ ${CHOST} == *-darwin* ]]; then
230 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib 227 # Set FLAGS *and* remove -arch, since our gcc-apple is multilib
231 # crippled (by design) :/ 228 # crippled (by design) :/
229 local mac_gpp_conf=
230 if [[ -f mkspecs/common/mac-g++.conf ]]; then
231 # qt < 4.8 has mac-g++.conf
232 mac_gpp_conf="mkspecs/common/mac-g++.conf"
233 elif [[ -f mkspecs/common/g++-macx.conf ]]; then
234 # qt >= 4.8 has g++-macx.conf
235 mac_gpp_conf="mkspecs/common/g++-macx.conf"
236 else
237 die "no known conf file for mac found"
238 fi
239 sed \
232 sed -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \ 240 -e "s:QMAKE_CFLAGS_RELEASE.*=.*:QMAKE_CFLAGS_RELEASE=${CFLAGS}:" \
233 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \ 241 -e "s:QMAKE_CXXFLAGS_RELEASE.*=.*:QMAKE_CXXFLAGS_RELEASE=${CXXFLAGS}:" \
234 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \ 242 -e "s:QMAKE_LFLAGS_RELEASE.*=.*:QMAKE_LFLAGS_RELEASE=-headerpad_max_install_names ${LDFLAGS}:" \
235 -e "s:-arch\s\w*::g" \ 243 -e "s:-arch\s\w*::g" \
236 -i mkspecs/common/mac-g++.conf || die "sed mkspecs/common/mac-g++.conf failed" 244 -i ${mac_gpp_conf} \
245 || die "sed ${mac_gpp_conf} failed"
237 246
238 # Fix configure's -arch settings that appear in qmake/Makefile and also 247 # Fix configure's -arch settings that appear in qmake/Makefile and also
239 # fix arch handling (automagically duplicates our -arch arg and breaks 248 # fix arch handling (automagically duplicates our -arch arg and breaks
240 # pch). Additionally disable Xarch support. 249 # pch). Additionally disable Xarch support.
250 local mac_gcc_confs="${mac_gpp_conf}"
251 if [[ -f mkspecs/common/gcc-base-macx.conf ]]; then
252 mac_gcc_confs+=" mkspecs/common/gcc-base-macx.conf"
253 fi
241 sed \ 254 sed \
242 -e "s:-arch i386::" \ 255 -e "s:-arch i386::" \
243 -e "s:-arch ppc::" \ 256 -e "s:-arch ppc::" \
244 -e "s:-arch x86_64::" \ 257 -e "s:-arch x86_64::" \
245 -e "s:-arch ppc64::" \ 258 -e "s:-arch ppc64::" \
246 -e "s:-arch \$i::" \ 259 -e "s:-arch \$i::" \
247 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \ 260 -e "/if \[ ! -z \"\$NATIVE_64_ARCH\" \]; then/,/fi/ d" \
248 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \ 261 -e "s:CFG_MAC_XARCH=yes:CFG_MAC_XARCH=no:g" \
249 -e "s:-Xarch_x86_64::g" \ 262 -e "s:-Xarch_x86_64::g" \
250 -e "s:-Xarch_ppc64::g" \ 263 -e "s:-Xarch_ppc64::g" \
251 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 264 -i configure ${mac_gcc_confs} \
265 || die "sed -arch/-Xarch failed"
252 266
253 # On Snow Leopard don't fall back to 10.5 deployment target. 267 # On Snow Leopard don't fall back to 10.5 deployment target.
254 if [[ ${CHOST} == *-apple-darwin10 ]] ; then 268 if [[ ${CHOST} == *-apple-darwin10 ]]; then
255 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \ 269 sed -e "s:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET.*:QMakeVar set QMAKE_MACOSX_DEPLOYMENT_TARGET 10.6:g" \
256 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \ 270 -e "s:-mmacosx-version-min=10.[0-9]:-mmacosx-version-min=10.6:g" \
257 -i configure mkspecs/common/mac-g++.conf || die "sed configure failed" 271 -i configure ${mac_gpp_conf} \
272 || die "sed deployment target failed"
258 fi 273 fi
259 fi 274 fi
260 275
261 # this one is needed for all systems with a separate -liconv, apart from 276 # this one is needed for all systems with a separate -liconv, apart from
262 # Darwin, for which the sources already cater for -liconv 277 # Darwin, for which the sources already cater for -liconv
263 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] ; then 278 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
264 sed \ 279 sed -e 's|mac:\(LIBS += -liconv\)|\1|g' \
265 -e "s|mac:LIBS += -liconv|LIBS += -liconv|g" \
266 -i config.tests/unix/iconv/iconv.pro \ 280 -i config.tests/unix/iconv/iconv.pro \
267 || die "sed on iconv.pro failed" 281 || die "sed iconv.pro failed"
268 fi 282 fi
269 283
270 # we need some patches for Solaris 284 # we need some patches for Solaris
271 sed -i \
272 -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \ 285 sed -i -e '/^QMAKE_LFLAGS_THREAD/a\QMAKE_LFLAGS_DYNAMIC_LIST = -Wl,--dynamic-list,' \
273 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 286 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
274 # use GCC over SunStudio 287 # use GCC over SunStudio
275 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die 288 sed -i -e '/PLATFORM=solaris-cc/s/cc/g++/' configure || die
276 # don't flirt with non-Prefix stuff, we're quite possessive 289 # do not flirt with non-Prefix stuff, we're quite possessive
277 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \ 290 sed -i -e '/^QMAKE_\(LIB\|INC\)DIR\(_X11\|_OPENGL\|\)\t/s/=.*$/=/' \
278 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die 291 mkspecs/$(qt_mkspecs_dir)/qmake.conf || die
279 # strip predefined CFLAGS from qmake ( bug #312689 )
280 sed -i '/^QMAKE_CFLAGS_\(RELEASE\|DEBUG\)/s:+=.*:+=:' mkspecs/common/g++.conf
281 292
282 base_src_prepare 293 # apply patches
294 [[ -n ${PATCHES[@]} ]] && epatch "${PATCHES[@]}"
295 epatch_user
283} 296}
284 297
285# @FUNCTION: qt4-build_src_configure 298# @FUNCTION: qt4-build_src_configure
286# @DESCRIPTION: 299# @DESCRIPTION:
287# Default configure phase 300# Default configure phase
288qt4-build_src_configure() { 301qt4-build_src_configure() {
289 setqtenv 302 setqtenv
290 myconf="$(standard_configure_options) ${myconf}" 303
304 local conf="
305 -prefix ${QTPREFIXDIR}
306 -bindir ${QTBINDIR}
307 -libdir ${QTLIBDIR}
308 -docdir ${QTDOCDIR}
309 -headerdir ${QTHEADERDIR}
310 -plugindir ${QTPLUGINDIR}
311 -importdir ${QTIMPORTDIR}
312 -datadir ${QTDATADIR}
313 -translationdir ${QTTRANSDIR}
314 -sysconfdir ${QTSYSCONFDIR}
315 -examplesdir ${QTEXAMPLESDIR}
316 -demosdir ${QTDEMOSDIR}
317 -opensource -confirm-license
318 -shared -fast -largefile -stl -verbose
319 -nomake examples -nomake demos"
320
321 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
322 # $(tc-arch). Therefore we convert it to supported values.
323 case "$(tc-arch)" in
324 amd64|x64-*) conf+=" -arch x86_64" ;;
325 ppc-macos) conf+=" -arch ppc" ;;
326 ppc|ppc64|ppc-*) conf+=" -arch powerpc" ;;
327 sparc|sparc-*|sparc64-*) conf+=" -arch sparc" ;;
328 x86-macos) conf+=" -arch x86" ;;
329 x86|x86-*) conf+=" -arch i386" ;;
330 alpha|arm|ia64|mips|s390) conf+=" -arch $(tc-arch)" ;;
331 hppa|sh) conf+=" -arch generic" ;;
332 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
333 esac
334
335 conf+=" -platform $(qt_mkspecs_dir)"
336
337 [[ $(get_libdir) != lib ]] && conf+=" -L${EPREFIX}/usr/$(get_libdir)"
338
339 # debug/release
340 if use debug; then
341 conf+=" -debug"
342 else
343 conf+=" -release"
344 fi
345 conf+=" -no-separate-debug-info"
346
347 # exceptions USE flag
348 conf+=" $(in_iuse exceptions && qt_use exceptions || echo -exceptions)"
349
350 # disable rpath (bug 380415), except on prefix (bug 417169)
351 use prefix || conf+=" -no-rpath"
352
353 # precompiled headers don't work on hardened, where the flag is masked
354 conf+=" $(qt_use pch)"
355
356 # -reduce-relocations
357 # This flag seems to introduce major breakage to applications,
358 # mostly to be seen as a core dump with the message "QPixmap: Must
359 # construct a QApplication before a QPaintDevice" on Solaris.
360 # -- Daniel Vergien
361 [[ ${CHOST} != *-solaris* ]] && conf+=" -reduce-relocations"
291 362
292 # this one is needed for all systems with a separate -liconv, apart from 363 # this one is needed for all systems with a separate -liconv, apart from
293 # Darwin, for which the sources already cater for -liconv 364 # Darwin, for which the sources already cater for -liconv
294 use !elibc_glibc && [[ ${CHOST} != *-darwin* ]] && \ 365 if use !elibc_glibc && [[ ${CHOST} != *-darwin* ]]; then
295 myconf+=" -liconv" 366 conf+=" -liconv"
367 fi
296 368
297 if has glib ${IUSE//+} && use glib; then 369 if use_if_iuse glib; then
298 # use -I, -L and -l from configure
299 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)" 370 local glibflags="$(pkg-config --cflags --libs glib-2.0 gthread-2.0)"
300 # avoid the -pthread argument 371 # avoid the -pthread argument
301 myconf+=" ${glibflags//-pthread}" 372 conf+=" ${glibflags//-pthread}"
302 unset glibflags 373 unset glibflags
303 fi 374 fi
304 375
305 if use aqua ; then 376 if use aqua; then
306 # On (snow) leopard use the new (frameworked) cocoa code. 377 # On (snow) leopard use the new (frameworked) cocoa code.
307 if [[ ${CHOST##*-darwin} -ge 9 ]] ; then 378 if [[ ${CHOST##*-darwin} -ge 9 ]]; then
308 myconf+=" -cocoa -framework" 379 conf+=" -cocoa -framework"
380 # We need the source's headers, not the installed ones.
381 conf+=" -I${S}/include"
382 # Add hint for the framework location.
383 conf+=" -F${QTLIBDIR}"
309 384
310 # We are crazy and build cocoa + qt3support :-) 385 # We are crazy and build cocoa + qt3support :-)
311 if use qt3support; then 386 if use qt3support; then
312 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \ 387 sed -e "/case \"\$PLATFORM,\$CFG_MAC_COCOA\" in/,/;;/ s|CFG_QT3SUPPORT=\"no\"|CFG_QT3SUPPORT=\"yes\"|" \
313 -i configure 388 -i configure || die
314 fi 389 fi
315 390 else
316 # We need the source's headers, not the installed ones. 391 conf+=" -no-framework"
317 myconf+=" -I${S}/include"
318
319 # Add hint for the framework location.
320 myconf+=" -F${QTLIBDIR}"
321 fi 392 fi
322 else 393 else
323 # freetype2 include dir is non-standard, thus include it on configure 394 # freetype2 include dir is non-standard, thus pass it to configure
324 # use -I from configure
325 myconf+=" $(pkg-config --cflags freetype2)" 395 conf+=" $(pkg-config --cflags-only-I freetype2)"
326 fi 396 fi
327 397
398 conf+=" ${myconf}"
399 myconf=
400
328 echo ./configure ${myconf} 401 echo ./configure ${conf}
329 ./configure ${myconf} || die "./configure failed" 402 ./configure ${conf} || die "./configure failed"
330 myconf="" 403
404 prepare_directories ${QT4_TARGET_DIRECTORIES}
331} 405}
332 406
333# @FUNCTION: qt4-build_src_compile 407# @FUNCTION: qt4-build_src_compile
408# @DESCRIPTION:
334# @DESCRIPTION: Actual compile phase 409# Actual compile phase
335qt4-build_src_compile() { 410qt4-build_src_compile() {
336 setqtenv 411 setqtenv
337 412
338 build_directories ${QT4_TARGET_DIRECTORIES} 413 build_directories ${QT4_TARGET_DIRECTORIES}
339} 414}
340 415
341# @FUNCTION: qt4-build_src_test 416# @FUNCTION: qt4-build_src_test
342# @DESCRIPTION: 417# @DESCRIPTION:
343# Runs tests only in target directories. 418# Runs tests only in target directories.
344qt4-build_src_test() { 419qt4-build_src_test() {
420 # QtMultimedia does not have any test suite (bug #332299)
421 [[ ${CATEGORY}/${PN} == dev-qt/qtmultimedia ]] && return
422
345 for dir in ${QT4_TARGET_DIRECTORIES}; do 423 for dir in ${QT4_TARGET_DIRECTORIES}; do
346 emake -j1 check -C ${dir} 424 emake -j1 check -C ${dir}
347 done 425 done
348} 426}
349 427
350# @FUNCTION: fix_includes 428# @FUNCTION: fix_includes
351# @DESCRIPTION: 429# @DESCRIPTION:
352# For MacOSX we need to add some symlinks when frameworks are 430# For MacOS X we need to add some symlinks when frameworks are
353# being used, to avoid complications with some more or less stupid packages. 431# being used, to avoid complications with some more or less stupid packages.
354fix_includes() { 432fix_includes() {
355 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]] ; then 433 if use aqua && [[ ${CHOST##*-darwin} -ge 9 ]]; then
434 local frw dest f h rdir
356 # Some packages tend to include <Qt/...> 435 # Some packages tend to include <Qt/...>
357 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt 436 dodir "${QTHEADERDIR#${EPREFIX}}"/Qt
358 437
359 # Fake normal headers when frameworks are installed... eases life later on 438 # Fake normal headers when frameworks are installed... eases life later
360 local dest f 439 # on, make sure we use relative links though, as some ebuilds assume
440 # these dirs exist in src_install to add additional files
441 f=${QTHEADERDIR}
442 h=${QTLIBDIR}
443 while [[ -n ${f} && ${f%%/*} == ${h%%/*} ]] ; do
444 f=${f#*/}
445 h=${h#*/}
446 done
447 rdir=${h}
448 f="../"
449 while [[ ${h} == */* ]] ; do
450 f="${f}../"
451 h=${h#*/}
452 done
453 rdir="${f}${rdir}"
454
361 for frw in "${D}${QTLIBDIR}"/*.framework; do 455 for frw in "${D}${QTLIBDIR}"/*.framework; do
362 [[ -e "${frw}"/Headers ]] || continue 456 [[ -e "${frw}"/Headers ]] || continue
363 f=$(basename ${frw}) 457 f=$(basename ${frw})
364 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework} 458 dest="${QTHEADERDIR#${EPREFIX}}"/${f%.framework}
365 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers "${dest}" 459 dosym "${rdir}"/${f}/Headers "${dest}"
366 460
367 # Link normal headers as well. 461 # Link normal headers as well.
368 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do 462 for hdr in "${D}/${QTLIBDIR}/${f}"/Headers/*; do
369 h=$(basename ${hdr}) 463 h=$(basename ${hdr})
370 dosym "${QTLIBDIR#${EPREFIX}}"/${f}/Headers/${h} "${QTHEADERDIR#${EPREFIX}}"/Qt/${h} 464 dosym "../${rdir}"/${f}/Headers/${h} \
465 "${QTHEADERDIR#${EPREFIX}}"/Qt/${h}
371 done 466 done
372 done 467 done
373 fi 468 fi
374} 469}
375 470
376# @FUNCTION: qt4-build_src_install 471# @FUNCTION: qt4-build_src_install
377# @DESCRIPTION: 472# @DESCRIPTION:
378# Perform the actual installation including some library fixes. 473# Perform the actual installation including some library fixes.
379qt4-build_src_install() { 474qt4-build_src_install() {
380 [[ ${EAPI} == 2 ]] && use !prefix && ED=${D}
381 setqtenv 475 setqtenv
476
382 install_directories ${QT4_TARGET_DIRECTORIES} 477 install_directories ${QT4_TARGET_DIRECTORIES}
383 install_qconfigs 478 install_qconfigs
384 fix_library_files 479 fix_library_files
385 fix_includes 480 fix_includes
481
482 # remove .la files since we are building only shared libraries
483 prune_libtool_files
386} 484}
387 485
388# @FUNCTION: setqtenv 486# @FUNCTION: setqtenv
487# @INTERNAL
389setqtenv() { 488setqtenv() {
390 # Set up installation directories 489 # Set up installation directories
391 QTBASEDIR=${EPREFIX}/usr/$(get_libdir)/qt4
392 QTPREFIXDIR=${EPREFIX}/usr 490 QTPREFIXDIR=${EPREFIX}/usr
393 QTBINDIR=${EPREFIX}/usr/bin 491 QTBINDIR=${QTPREFIXDIR}/bin
394 QTLIBDIR=${EPREFIX}/usr/$(get_libdir)/qt4 492 QTLIBDIR=${QTPREFIXDIR}/$(get_libdir)/qt4
395 QMAKE_LIBDIR_QT=${QTLIBDIR}
396 QTPCDIR=${EPREFIX}/usr/$(get_libdir)/pkgconfig 493 QTPCDIR=${QTPREFIXDIR}/$(get_libdir)/pkgconfig
397 QTDATADIR=${EPREFIX}/usr/share/qt4
398 QTDOCDIR=${EPREFIX}/usr/share/doc/qt-${PV} 494 QTDOCDIR=${QTPREFIXDIR}/share/doc/qt-${PV}
399 QTHEADERDIR=${EPREFIX}/usr/include/qt4 495 QTHEADERDIR=${QTPREFIXDIR}/include/qt4
400 QTPLUGINDIR=${QTLIBDIR}/plugins 496 QTPLUGINDIR=${QTLIBDIR}/plugins
497 QTIMPORTDIR=${QTLIBDIR}/imports
498 QTDATADIR=${QTPREFIXDIR}/share/qt4
499 QTTRANSDIR=${QTDATADIR}/translations
401 QTSYSCONFDIR=${EPREFIX}/etc/qt4 500 QTSYSCONFDIR=${EPREFIX}/etc/qt4
402 QTTRANSDIR=${QTDATADIR}/translations
403 QTEXAMPLESDIR=${QTDATADIR}/examples 501 QTEXAMPLESDIR=${QTDATADIR}/examples
404 QTDEMOSDIR=${QTDATADIR}/demos 502 QTDEMOSDIR=${QTDATADIR}/demos
405 QT_INSTALL_PREFIX=${EPREFIX}/usr/$(get_libdir)/qt4 503 QMAKE_LIBDIR_QT=${QTLIBDIR}
504
406 PLATFORM=$(qt_mkspecs_dir) 505 PLATFORM=$(qt_mkspecs_dir)
407
408 unset QMAKESPEC 506 unset QMAKESPEC
409}
410 507
411# @FUNCTION: standard_configure_options 508 export XDG_CONFIG_HOME="${T}"
412# @DESCRIPTION: 509}
413# Sets up some standard configure options, like libdir (if necessary), whether
414# debug info is wanted or not.
415standard_configure_options() {
416 local myconf=
417 510
418 [[ $(get_libdir) != lib ]] && myconf+=" -L${EPREFIX}/usr/$(get_libdir)" 511# @FUNCTION: prepare_directories
419 512# @USAGE: < directories >
420 # Disable visibility explicitly if gcc version isn't 4 513# @INTERNAL
421 if [[ $(gcc-major-version) -lt 4 ]]; then 514# @DESCRIPTION:
422 myconf+=" -no-reduce-exports" 515# Generates Makefiles for the given list of directories.
423 fi 516prepare_directories() {
424 517 for x in "$@"; do
425 # precompiled headers doesn't work on hardened, where the flag is masked. 518 pushd "${S}"/${x} >/dev/null || die
426 myconf+=" $(qt_use pch)" 519 einfo "Running qmake in: ${x}"
427 520 "${S}"/bin/qmake \
428 if use debug; then 521 "LIBS+=-L${QTLIBDIR}" \
429 myconf+=" -debug" 522 "CONFIG+=nostrip" \
430 else 523 || die "qmake failed"
431 myconf+=" -release" 524 popd >/dev/null || die
432 fi 525 done
433 myconf+=" -no-separate-debug-info"
434
435 use aqua && myconf+=" -no-framework"
436
437 # ARCH is set on Gentoo. Qt now falls back to generic on an unsupported
438 # $(tc-arch). Therefore we convert it to supported values.
439 case "$(tc-arch)" in
440 amd64|x64-*) myconf+=" -arch x86_64" ;;
441 ppc-macos) myconf+=" -arch ppc" ;;
442 ppc|ppc64|ppc-*) myconf+=" -arch powerpc" ;;
443 sparc|sparc-*) myconf+=" -arch sparc" ;;
444 x86-macos) myconf+=" -arch x86" ;;
445 x86|x86-*) myconf+=" -arch i386" ;;
446 alpha|arm|ia64|mips|s390|sparc) myconf+=" -arch $(tc-arch)" ;;
447 hppa|sh) myconf+=" -arch generic" ;;
448 *) die "$(tc-arch) is unsupported by this eclass. Please file a bug." ;;
449 esac
450
451 # 4.5: build everything but qt-xmlpatterns w/o exceptions
452 # 4.6: exceptions USE flag
453 local exceptions="-exceptions"
454 case "${PV}" in
455 4.5.*)
456 [[ ${PN} == "qt-xmlpatterns" ]] || exceptions="-no-exceptions"
457 ;;
458 *)
459 has exceptions "${IUSE//+}" && exceptions="$(qt_use exceptions)"
460 ;;
461 esac
462
463 # note about -reduce-relocations:
464 # That flag seems to introduce major breakage to applications,
465 # mostly to be seen as a core dump with the message "QPixmap: Must
466 # construct a QApplication before a QPaintDevice" on Solaris
467 # -- Daniel Vergien
468 [[ ${CHOST} != *-solaris* ]] && myconf+=" -reduce-relocations"
469
470 myconf+=" -platform $(qt_mkspecs_dir) -stl -verbose -largefile -confirm-license
471 -prefix ${QTPREFIXDIR} -bindir ${QTBINDIR} -libdir ${QTLIBDIR}
472 -datadir ${QTDATADIR} -docdir ${QTDOCDIR} -headerdir ${QTHEADERDIR}
473 -plugindir ${QTPLUGINDIR} -sysconfdir ${QTSYSCONFDIR}
474 -translationdir ${QTTRANSDIR} -examplesdir ${QTEXAMPLESDIR}
475 -demosdir ${QTDEMOSDIR} -silent -fast -opensource
476 ${exceptions}
477 -nomake examples -nomake demos"
478
479 echo "${myconf}"
480} 526}
481 527
482# @FUNCTION: build_directories 528# @FUNCTION: build_directories
483# @USAGE: < directories > 529# @USAGE: < directories >
530# @INTERNAL
484# @DESCRIPTION: 531# @DESCRIPTION:
485# Compiles the code in $QT4_TARGET_DIRECTORIES 532# Compiles the code in the given list of directories.
486build_directories() { 533build_directories() {
487 for x in "$@"; do 534 for x in "$@"; do
488 pushd "${S}"/${x} >/dev/null 535 pushd "${S}"/${x} >/dev/null || die
489 # avoid running over the maximum argument number, bug #299810 536 emake \
490 { 537 AR="$(tc-getAR) cqs" \
491 echo "${S}"/mkspecs/common/*.conf
492 find "${S}" -name '*.pr[io]'
493 } | xargs sed -i -e "s:\$\$\[QT_INSTALL_LIBS\]:${EPREFIX}/usr/$(get_libdir)/qt4:g" || die
494 "${S}"/bin/qmake "LIBS+=-L${QTLIBDIR}" "CONFIG+=nostrip" || die "qmake failed"
495 emake CC="$(tc-getCC)" \ 538 CC="$(tc-getCC)" \
496 CXX="$(tc-getCXX)" \ 539 CXX="$(tc-getCXX)" \
497 LINK="$(tc-getCXX)" || die "emake failed" 540 LINK="$(tc-getCXX)" \
541 RANLIB=":" \
542 STRIP=":"
498 popd >/dev/null 543 popd >/dev/null || die
499 done 544 done
500} 545}
501 546
502# @FUNCTION: install_directories 547# @FUNCTION: install_directories
503# @USAGE: < directories > 548# @USAGE: < directories >
549# @INTERNAL
504# @DESCRIPTION: 550# @DESCRIPTION:
505# run emake install in the given directories, which are separated by spaces 551# Runs emake install in the given directories, which are separated by spaces.
506install_directories() { 552install_directories() {
507 for x in "$@"; do 553 for x in "$@"; do
508 pushd "${S}"/${x} >/dev/null || die "Can't pushd ${S}/${x}" 554 pushd "${S}"/${x} >/dev/null || die
509 emake INSTALL_ROOT="${D}" install || die "emake install failed" 555 emake INSTALL_ROOT="${D}" install
510 popd >/dev/null || die "Can't popd from ${S}/${x}" 556 popd >/dev/null || die
511 done 557 done
512} 558}
513 559
514# @ECLASS-VARIABLE: QCONFIG_ADD 560# @ECLASS-VARIABLE: QCONFIG_ADD
515# @DESCRIPTION: 561# @DESCRIPTION:
525# @DESCRIPTION: 571# @DESCRIPTION:
526# List variables that should be defined at the top of QtCore/qconfig.h 572# List variables that should be defined at the top of QtCore/qconfig.h
527: ${QCONFIG_DEFINE:=} 573: ${QCONFIG_DEFINE:=}
528 574
529# @FUNCTION: install_qconfigs 575# @FUNCTION: install_qconfigs
576# @INTERNAL
577# @DESCRIPTION:
530# @DESCRIPTION: Install gentoo-specific mkspecs configurations 578# Install gentoo-specific mkspecs configurations.
531install_qconfigs() { 579install_qconfigs() {
532 local x 580 local x
533 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then 581 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} ]]; then
534 for x in QCONFIG_ADD QCONFIG_REMOVE; do 582 for x in QCONFIG_ADD QCONFIG_REMOVE; do
535 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri 583 [[ -n ${!x} ]] && echo ${x}=${!x} >> "${T}"/${PN}-qconfig.pri
536 done 584 done
537 insinto ${QTDATADIR#${EPREFIX}}/mkspecs/gentoo 585 insinto ${QTDATADIR#${EPREFIX}}/mkspecs/gentoo
538 doins "${T}"/${PN}-qconfig.pri || die "installing ${PN}-qconfig.pri failed" 586 doins "${T}"/${PN}-qconfig.pri
539 fi 587 fi
540 588
541 if [[ -n ${QCONFIG_DEFINE} ]]; then 589 if [[ -n ${QCONFIG_DEFINE} ]]; then
542 for x in ${QCONFIG_DEFINE}; do 590 for x in ${QCONFIG_DEFINE}; do
543 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h 591 echo "#define ${x}" >> "${T}"/gentoo-${PN}-qconfig.h
544 done 592 done
545 insinto ${QTHEADERDIR#${EPREFIX}}/Gentoo 593 insinto ${QTHEADERDIR#${EPREFIX}}/Gentoo
546 doins "${T}"/gentoo-${PN}-qconfig.h || die "installing ${PN}-qconfig.h failed" 594 doins "${T}"/gentoo-${PN}-qconfig.h
547 fi 595 fi
548} 596}
549 597
550# @FUNCTION: generate_qconfigs 598# @FUNCTION: generate_qconfigs
551# @DESCRIPTION: Generates gentoo-specific configurations 599# @INTERNAL
600# @DESCRIPTION:
601# Generates gentoo-specific qconfig.{h,pri}.
552generate_qconfigs() { 602generate_qconfigs() {
553 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == x11-libs/qt-core ]]; then 603 if [[ -n ${QCONFIG_ADD} || -n ${QCONFIG_REMOVE} || -n ${QCONFIG_DEFINE} || ${CATEGORY}/${PN} == dev-qt/qtcore ]]; then
554 local x qconfig_add qconfig_remove qconfig_new 604 local x qconfig_add qconfig_remove qconfig_new
555 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do 605 for x in "${ROOT}${QTDATADIR}"/mkspecs/gentoo/*-qconfig.pri; do
556 [[ -f ${x} ]] || continue 606 [[ -f ${x} ]] || continue
557 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")" 607 qconfig_add+=" $(sed -n 's/^QCONFIG_ADD=//p' "${x}")"
558 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")" 608 qconfig_remove+=" $(sed -n 's/^QCONFIG_REMOVE=//p' "${x}")"
559 done 609 done
560 610
561 # these error checks do not use die because dying in pkg_post{inst,rm} 611 # these error checks do not use die because dying in pkg_post{inst,rm}
562 # just makes things worse. 612 # just makes things worse.
563 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then 613 if [[ -e "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri ]]; then
564 # start with the qconfig.pri that qt-core installed 614 # start with the qconfig.pri that qtcore installed
565 if ! cp "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri \ 615 if ! cp "${ROOT}${QTDATADIR}"/mkspecs/gentoo/qconfig.pri \
566 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 616 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
567 eerror "cp qconfig failed." 617 eerror "cp qconfig failed."
568 return 1 618 return 1
569 fi 619 fi
570 620
571 # generate list of QT_CONFIG entries from the existing list 621 # generate list of QT_CONFIG entries from the existing list
572 # including qconfig_add and excluding qconfig_remove 622 # including qconfig_add and excluding qconfig_remove
573 for x in $(sed -n 's/^QT_CONFIG +=//p' \ 623 for x in $(sed -n 's/^QT_CONFIG +=//p' \
574 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do 624 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri) ${qconfig_add}; do
575 hasq ${x} ${qconfig_remove} || qconfig_new+=" ${x}" 625 has ${x} ${qconfig_remove} || qconfig_new+=" ${x}"
576 done 626 done
577 627
578 # replace the existing QT_CONFIG list with qconfig_new 628 # replace the existing QT_CONFIG list with qconfig_new
579 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \ 629 if ! sed -i -e "s/QT_CONFIG +=.*/QT_CONFIG += ${qconfig_new}/" \
580 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then 630 "${ROOT}${QTDATADIR}"/mkspecs/qconfig.pri; then
604 fi 654 fi
605 fi 655 fi
606} 656}
607 657
608# @FUNCTION: qt4-build_pkg_postrm 658# @FUNCTION: qt4-build_pkg_postrm
659# @DESCRIPTION:
609# @DESCRIPTION: Generate configurations when the package is completely removed 660# Regenerate configuration when the package is completely removed.
610qt4-build_pkg_postrm() { 661qt4-build_pkg_postrm() {
611 generate_qconfigs 662 generate_qconfigs
612} 663}
613 664
614# @FUNCTION: qt4-build_pkg_postinst 665# @FUNCTION: qt4-build_pkg_postinst
666# @DESCRIPTION:
615# @DESCRIPTION: Generate configuration, plus throws a message about possible 667# Regenerate configuration, plus throw a message about possible
616# breakages and proposed solutions. 668# breakages and proposed solutions.
617qt4-build_pkg_postinst() { 669qt4-build_pkg_postinst() {
618 generate_qconfigs 670 generate_qconfigs
619} 671}
620 672
621# @FUNCTION: skip_qmake_build_patch 673# @FUNCTION: skip_qmake_build
674# @INTERNAL
622# @DESCRIPTION: 675# @DESCRIPTION:
623# Don't need to build qmake, as it's already installed from qt-core 676# Patches configure to skip qmake compilation, as it's already installed by qtcore.
624skip_qmake_build_patch() { 677skip_qmake_build() {
625 # Don't need to build qmake, as it's already installed from qt-core
626 sed -i -e "s:if true:if false:g" "${S}"/configure || die "Sed failed" 678 sed -i -e "s:if true:if false:g" "${S}"/configure || die
627} 679}
628 680
629# @FUNCTION: skip_project_generation_patch 681# @FUNCTION: skip_project_generation
682# @INTERNAL
630# @DESCRIPTION: 683# @DESCRIPTION:
631# Exit the script early by throwing in an exit before all of the .pro files are scanned 684# Exit the script early by throwing in an exit before all of the .pro files are scanned.
632skip_project_generation_patch() { 685skip_project_generation() {
633 # Exit the script early by throwing in an exit before all of the .pro files are scanned
634 sed -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" \ 686 sed -i -e "s:echo \"Finding:exit 0\n\necho \"Finding:g" "${S}"/configure || die
635 -i "${S}"/configure || die "Sed failed"
636} 687}
637 688
638# @FUNCTION: symlink_binaries_to_buildtree 689# @FUNCTION: symlink_binaries_to_buildtree
690# @INTERNAL
639# @DESCRIPTION: 691# @DESCRIPTION:
640# Symlink generated binaries to buildtree so they can be used during compilation 692# Symlinks generated binaries to buildtree, so they can be used during compilation time.
641# time
642symlink_binaries_to_buildtree() { 693symlink_binaries_to_buildtree() {
643 for bin in qmake moc uic rcc; do 694 for bin in qmake moc uic rcc; do
644 ln -s ${QTBINDIR}/${bin} "${S}"/bin/ || die "Symlinking ${bin} to ${S}/bin failed." 695 ln -s "${QTBINDIR}"/${bin} "${S}"/bin/ || die "symlinking ${bin} to ${S}/bin failed"
645 done 696 done
646} 697}
647 698
648# @FUNCTION: fix_library_files 699# @FUNCTION: fix_library_files
700# @INTERNAL
649# @DESCRIPTION: 701# @DESCRIPTION:
650# Fixes the pathes in *.la, *.prl, *.pc, as they are wrong due to sandbox and 702# Fixes the paths in *.la, *.prl, *.pc, as they are wrong due to sandbox and
651# moves the *.pc-files into the pkgconfig directory 703# moves the *.pc files into the pkgconfig directory.
652fix_library_files() { 704fix_library_files() {
705 local libfile
653 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do 706 for libfile in "${D}"/${QTLIBDIR}/{*.la,*.prl,pkgconfig/*.pc}; do
654 if [[ -e ${libfile} ]]; then 707 if [[ -e ${libfile} ]]; then
655 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "Sed on ${libfile} failed." 708 sed -i -e "s:${S}/lib:${QTLIBDIR}:g" ${libfile} || die "sed on ${libfile} failed"
656 fi 709 fi
657 done 710 done
658 711
659 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations. Fix: 712 # pkgconfig files refer to WORKDIR/bin as the moc and uic locations
660 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do 713 for libfile in "${D}"/${QTLIBDIR}/pkgconfig/*.pc; do
661 if [[ -e ${libfile} ]]; then 714 if [[ -e ${libfile} ]]; then
662 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "Sed failed" 715 sed -i -e "s:${S}/bin:${QTBINDIR}:g" ${libfile} || die "sed on ${libfile} failed"
663 716
664 # Move .pc files into the pkgconfig directory 717 # Move .pc files into the pkgconfig directory
665 dodir ${QTPCDIR#${EPREFIX}} 718 dodir ${QTPCDIR#${EPREFIX}}
666 mv ${libfile} "${D}"/${QTPCDIR}/ \ 719 mv ${libfile} "${D}"/${QTPCDIR}/ || die "moving ${libfile} to ${D}/${QTPCDIR}/ failed"
667 || die "Moving ${libfile} to ${D}/${QTPCDIR}/ failed."
668 fi 720 fi
669 done 721 done
670 722
671 # Don't install an empty directory 723 # Don't install an empty directory
672 rmdir "${D}"/${QTLIBDIR}/pkgconfig 724 rmdir "${D}"/${QTLIBDIR}/pkgconfig
673} 725}
674 726
675# @FUNCTION: qt_use 727# @FUNCTION: qt_use
676# @USAGE: < flag > [ feature ] [ enableval ] 728# @USAGE: < flag > [ feature ] [ enableval ]
677# @DESCRIPTION: 729# @DESCRIPTION:
678# This will echo "${enableval}-${feature}" if <flag> is enabled, or 730# This will echo "-${enableval}-${feature}" if <flag> is enabled, or
679# "-no-${feature} if the flag is disabled. If [feature] is not specified <flag> 731# "-no-${feature}" if it's disabled. If [feature] is not specified, <flag>
680# will be used for that. If [enableval] is not specified, it omits the 732# will be used for that. If [enableval] is not specified, it omits the
681# assignment-part 733# "-${enableval}" part.
682qt_use() { 734qt_use() {
683 local flag=$1 735 use "$1" && echo "${3:+-$3}-${2:-$1}" || echo "-no-${2:-$1}"
684 local feature=$1
685 local enableval=
686
687 [[ -n $2 ]] && feature=$2
688 [[ -n $3 ]] && enableval=-$3
689
690 if use ${flag}; then
691 echo "${enableval}-${feature}"
692 else
693 echo "-no-${feature}"
694 fi
695} 736}
696 737
697# @FUNCTION: qt_mkspecs_dir 738# @FUNCTION: qt_mkspecs_dir
698# @RETURN: the specs-directory w/o path 739# @RETURN: the specs-directory w/o path
699# @DESCRIPTION: 740# @DESCRIPTION:
700# Allows us to define which mkspecs dir we want to use. 741# Allows us to define which mkspecs dir we want to use.
701qt_mkspecs_dir() { 742qt_mkspecs_dir() {
702 # Allows us to define which mkspecs dir we want to use.
703 local spec 743 local spec=
704 744
705 case ${CHOST} in 745 case "${CHOST}" in
706 *-freebsd*|*-dragonfly*) 746 *-freebsd*|*-dragonfly*)
707 spec=freebsd ;; 747 spec=freebsd ;;
708 *-openbsd*) 748 *-openbsd*)
709 spec=openbsd ;; 749 spec=openbsd ;;
710 *-netbsd*) 750 *-netbsd*)
721 *-solaris*) 761 *-solaris*)
722 spec=solaris ;; 762 spec=solaris ;;
723 *-linux-*|*-linux) 763 *-linux-*|*-linux)
724 spec=linux ;; 764 spec=linux ;;
725 *) 765 *)
726 die "Unknown CHOST, no platform choosen." 766 die "${FUNCNAME}(): Unknown CHOST '${CHOST}'" ;;
727 esac 767 esac
728 768
729 CXX=$(tc-getCXX) 769 case "$(tc-getCXX)" in
730 if [[ ${CXX} == *g++* ]]; then 770 *g++*)
731 spec+=-g++ 771 spec+=-g++ ;;
732 elif [[ ${CXX} == *icpc* ]]; then 772 *icpc*)
733 spec+=-icc 773 spec+=-icc ;;
734 else 774 *)
735 die "Unknown compiler ${CXX}." 775 die "${FUNCNAME}(): Unknown compiler '$(tc-getCXX)'" ;;
736 fi 776 esac
737 if [[ -n ${LIBDIR/lib} ]]; then
738 spec+=-${LIBDIR/lib}
739 fi
740 777
741 # Add -64 for 64bit profiles 778 # Add -64 for 64bit profiles
742 if use x64-freebsd || 779 if use x64-freebsd ||
743 use amd64-linux || 780 use amd64-linux ||
744 use x64-macos || 781 use x64-macos ||
749 fi 786 fi
750 787
751 echo "${spec}" 788 echo "${spec}"
752} 789}
753 790
791# @FUNCTION: qt_nolibx11
792# @INTERNAL
793# @DESCRIPTION:
794# Skip X11 tests for packages that don't need X libraries installed.
795qt_nolibx11() {
796 sed -i -e '/^if.*PLATFORM_X11.*CFG_GUI/,/^fi$/d' "${S}"/configure || die
797}
798
754EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst 799EXPORT_FUNCTIONS pkg_setup src_unpack src_prepare src_configure src_compile src_install src_test pkg_postrm pkg_postinst

Legend:
Removed from v.1.76  
changed lines
  Added in v.1.149

  ViewVC Help
Powered by ViewVC 1.1.20